package graphs.traversal;

import graphs.*;
import java.util.*;

/** 
 * Represents the breadth-first search in an undirected graph. 
 *
 * @author V.B.
 * @version 2.0.0 Dec 2001
 */
public class BFS extends Traversal {
  
	private List levels; //list of levels (array lists conaining veritces)
	
	public BFS() {
		super();
		levels = new ArrayList();
	}
	
  /**
   * Breadth-first search starting at vertex v, using levels.
   * The first level contains the vertex v only; the last level is empty.
   */
  public Object visit(Vertex v) {
    ArrayList l0 = new ArrayList();
    l0.add(v);
    levels.add(l0);
		
    while (! l0.isEmpty()) {
    	ArrayList l = new ArrayList();
    	
    	for (Iterator vs = l0.iterator(); vs.hasNext(); ) {
    		Vertex cv = (Vertex) vs.next();
    		
    		for (Iterator cs = graph.incidentEdges(cv); cs.hasNext();) {
    			Edge ce = (Edge) cs.next();
    			if (! isMarked(ce)) {
    				Vertex w = graph.opposite(cv, ce);
    				if (! isMarked(w)) {
    					traverseDiscovery(ce, cv);
    					mark(w);
    					l.add(w);
    				} else {
    					traverseCross(ce, cv);
    				}
    			}//if
    		}//for
    		
    	}//for
    	levels.add(l);
    	l0 = l;
    }//while
  	
    return result();
  }
  
  protected void traverseDiscovery(Edge e, Vertex from) {}
  
  protected void traverseCross(Edge e, Vertex from) {}
  
  public Object result() {
    return levels;
  }
  


}