package graphs.traversal;

import graphs.*;
import java.util.Iterator;


/**
 * This class uses a specialized DFS to test if a graph is connected.
 * It runs FindAllVerticesDFS and then checks if the number of vertices
 * visited is equal to the total number of vertices in the graph.
 *
 * @version 1.1.0 Dec 2001
 */
 public class ConnectivityTest {
  
  protected static DFS tester = new FindAllVerticesDFS();
  
  public static boolean isConnected(Graph graph) {
    if (graph.numVertices() == 0) return true; //an empty graph is connected
    Vertex start = (Vertex) graph.vertices().next();
    Iterator compVerts = (Iterator) tester.execute(graph, start, null);    
    int count = 0;
    while (compVerts.hasNext()) {
      compVerts.next();
      count++;
    }
    if (count == graph.numVertices()) return true;
    return false;  
  }
  
     
 }