package graphs.traversal;

import graphs.*;
import java.util.*;

/**
 * This class specializes BFS to return an iterator of the vertices in
 * the connected component of the start vertex. 
 *
 * @version 1.0.0 Dec 2001
 */
 public class FindAllVerticesBFS extends BFS {
  
 	protected ArrayList vertices;
  
 	/** Runs the BFS visit and returns the visited vertices */
  public Object execute(Graph graph, Vertex start, Object info) {
    super.execute(graph, start, info);
    visit(start);
    vertices = getVisited();
    return vertices.iterator();
  }
  
  /**
   * Adds vertices in BFS order
   */
  public void startVisit(Vertex v) {
    vertices.add(v);
  }
  
  /** Gets a list of all visited vertices */
  public ArrayList getVisited() {
  	ArrayList vs = new ArrayList();
		List tmp = (List) result();
		for (Iterator it = tmp.iterator(); it.hasNext();) {
			for (Iterator it1 = ((ArrayList) it.next()).iterator(); it1.hasNext();) {
				vs.add(it1.next());
			}
		}
		return vs;
  }
  
  	
 }