package graphs.traversal;

import graphs.*;
import java.util.ArrayList;

/**
 * This class specializes DFS to return an iterator of the vertices in
 * the connected component of the start vertex. 
 *
 * @version 1.1.0 Dec 2001
 */
 public class FindAllVerticesDFS extends DFS {
  
 	protected ArrayList vertices;
  
 	/** Retuns an iterator of all visited vertices */
  public Object execute(Graph graph, Vertex start, Object info) {
    super.execute(graph, start, info);
    vertices = new ArrayList();
    visit(start);
    return vertices.iterator();
  }
  
  /**
   * Adds vertices in DFS order
   */
  public void startVisit(Vertex v) {
    vertices.add(v);
  }
     
 }